alias linkedlist {
  if ($0) {
    var %name = $1
    if ($isid) {
      var %ll_name = $linkedlist_getname(%name)
      if (%ll_name isnum) { return %ll_name }
      if ($hget(%ll_name)) {
        var %ref = $hget(%ll_name,ref)
        if ($prop == head) {
          return $hget(%ll_name,next)
        }
        elseif ($prop == ref) {
          return %ref
        }
        elseif ($prop == tail) {
          return $hget(%ll_name,tail)
        }
        else {
          return $gettok(%ll_name,2,247)
        }
      }
      else {
        return
      }
    }
    else {
      if ($show) { linkedlist_error linkedlist must be called as an identifier }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist insufficient parameters }
  }
}

alias linkedlist_node {
  var %name = $linkedlist_getname($1), %node = $2
  if (%name isnum) { return %name }
  %name = $gettok(%name,2,247)
  if ((%name) && (%node >= 0)) {
    var %nodename = $linkedlist_name(%name,%node)
    var %exists = $hget(%nodename)
    if ($isid) {
      if ($prop == next) {
        return $hget(%nodename,next)
      }
      elseif ($prop == data) {
        return $hget(%nodename,data)
      }
      elseif ($prop == item) {
        return $hget(%nodename,item)
      }
      else {
        if (%exists) {
          return $true
        }
        else {
          return $false
        }
      }
    }
    else {
      if ($show) { linkedlist_error linkedlist_node must be called as an identifier }
    }
  }
}

alias linkedlist_insert {
  if ($left($1,1) == -) {
    var %flagstore = $1
    if (m isin $1) {
      var %make = $true
    }
    if (s isin $1) {
      var %show = $true
    }
    tokenize 32 $2-
  }
  var %name = $1, %item = $2, %data = $3-
  if ($0 >= 2) {
    var %exists = $linkedlist(%name)
    if ((%exists) || (%make)) {
      var %tail = $linkedlist(%name).tail
      linkedlist_insertAfter $iif((%show) || (%make),%flagstore) %name %tail %item %data
    }
    else {
      if ($show) { linkedlist_error linkedlist_insert no such linked list ' $+ %name $+ ' }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_insert insufficient parameters }
  }
}

alias linkedlist_remove {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
    }
    tokenize 32 $2-
  }
  var %name = $1, %node = $2
  if (($0 == 2) && (%node > 0)) {
    if ($linkedlist(%name)) {
      if ($linkedlist_node(%name,%node)) {
        var %next = $linkedlist_node(%name,0).next
        while (%next != $null) {
          var %currentnode = %next
          var %nextnode = $linkedlist_node(%name,%currentnode).next
          if (%nextnode == %node) {
            linkedlist_removeAfter $iif(%show,-s) %name %currentnode
          }
          %next = $linkedlist_node(%name,%currentnode).next
        }
      }
      else {
        if ($show) { linkedlist_error linkedlist_remove no such node in ' $+ %name $+ ' (node: %node $+ )  }
      }
    }
    else {
      if ($show) { linkedlist_error linkedlist_remove no such linked list ' $+ %name $+ ' }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_remove insufficient parameters }
  }
}

alias linkedlist_insertAfter {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
    }
    if (m isin $1) {
      var %make = $true
    }
    tokenize 32 $2-
  }
  var %name = $1, %node = $2, %item = $3, %data = $4-
  if (($0 >= 3) && (%node >= 0)) {
    var %exists = $linkedlist(%name)
    if ((%exists) || (%make)) {
      if (%make) {
        if (!%exists) { linkedlist_make %name }
      }
      if ($linkedlist_node(%name,%node)) {
        var %ll_name = $linkedlist_name(%name,0)
        var %next = $linkedlist(%name).ref
        inc %next 1
        var %prevnode.next = $linkedlist_node(%name,%node).next
        var %newnode = $linkedlist_name(%name,%next)
        hmake %newnode 3
        linkedlist_set %name %next data %data
        linkedlist_set %name %next item %item
        linkedlist_set %name %next next %prevnode.next
        linkedlist_set %name %node next %next
        hinc %ll_name ref 1
        if (%prevnode.next == $null) {
          hadd %ll_name tail %next
        }
        if ((%show) && ($show)) { linkedlist_info Added item ' $+ %item $+ ' to linked list ' $+ %name $+ ' (node: %next $+ ) }
      }
      else {
        if ($show) { linkedlist_error linkedlist_insertAfter no such node in ' $+ %name $+ ' (node: %node $+ )  }
      }
    }
    else {
      if ($show) { linkedlist_error linkedlist_insertAfter no such linked list ' $+ %name $+ ' }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_insertAfter insufficient parameters }
  }
}

alias linkedlist_removeAfter {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
    }
    tokenize 32 $2-
  }
  var %name = $1, %node = $2
  if (($0 == 2) && (%node >= 0)) {
    if ($linkedlist(%name)) {
      if ($linkedlist_node(%name,%node)) {
        var %next = $linkedlist_node(%name,%node).next
        var %nodename = $linkedlist_name(%name,%node)
        if (%next != $null) {
          var %ll_name = $linkedlist_name(%name,0)
          var %remnext = $linkedlist_node(%name,%next).next
          hadd %nodename next %remnext
          hfree $linkedlist_name(%name,%next)
          if (%remnext == $null) {
            hadd %ll_name tail %node
          }
          if ((%show) && ($show)) { linkedlist_info Deleted node ' $+ %node $+ ' from linked list ' $+ %name $+ ' }
        }
        else {
          if ($show) { linkedlist_error linkedlist_removeAfter node is tail ' $+ %name $+ ' (node: %node $+ )  }
        }
      }
      else {
        if ($show) { linkedlist_error linkedlist_removeAfter no such node in ' $+ %name $+ ' (node: %node $+ )  }
      }
    }
    else {
      if ($show) { linkedlist_error linkedlist_removeAfter no such linked list ' $+ %name $+ ' }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_removeAfter insufficient parameters }
  }
}

alias linkedlist_insertBeginning {
  if ($left($1,1) == -) {
    var %flagstore = $1
    if (m isin $1) {
      var %make = $true
    }
    if (s isin $1) {
      var %show = $true
    }
    tokenize 32 $2-
  }
  var %name = $1, %item = $2, %data = $3-
  if ($0 >= 2) {
    if ($linkedlist(%name)) {
      linkedlist_insertAfter $iif((%show) || (%make),%flagstore) %name 0 %item %data
    }
    else {
      if ($show) { linkedlist_error linkedlist_insertBeginning no such linked list ' $+ %name $+ ' }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_insertBeginning insufficient parameters }
  }
}

alias linkedlist_removeBeginning {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
    }
    tokenize 32 $2-
  }
  var %name = $1
  if ($0 == 1) {
    if ($linkedlist(%name)) {
      if ($linkedlist(%name).head) {
        linkedlist_removeAfter $iif(%show,-s) %name 0
      }
      else {
        if ($show) { linkedlist_error linkedlist_removeBeginning no beginning node in linked list ' $+ %name $+ ' }
      }
    }
    else {
      if ($show) { linkedlist_error linkedlist_removeBeginning no such linked list ' $+ %name $+ ' }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_removeBeginning insufficient parameters }
  }
}

alias linkedlist_make {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
    }
    tokenize 32 $2-
  }
  var %name = $1
  if (%name) {
    if (!$linkedlist(%name)) {
      var %ll_name = $linkedlist_name(%name,0)
      hmake %ll_name 3
      hadd %ll_name ref 0
      hadd %ll_name next $null
      hadd %ll_name tail 0
      if (($show) && (%show)) { linkedlist_info Made linked list ' $+ %name $+ ' }
    }
    else {
      if ($show) { linkedlist_error linkedlist_make linked list ' $+ %name $+ ' exists }
    }
  }
}

alias linkedlist_free {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
    }
    if (w isin $1) {
      var %wild = $true
    }
    tokenize 32 $2-
  }
  var %name = $1
  if (%name) {
    var %free
    if (!%wild) {
      %free = $+(ll,%name,*)
      if (!$linkedlist(%name)) {
        if ($show) { linkedlist_error linkedlist_free no such linked list  ' $+ %name $+ ' }
        return
      }
    }
    else {
      %free = $+(ll,%name,*)
    }
    hfree -w %free
    if ((%show) && (!%wild) && ($show)) { linkedlist_info Freed linked list ' $+ %name $+ ' }
  }
}

alias linkedlist_dec {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
    }
    tokenize 32 $2-
  }
  linkedlist_inc $iif(%show,-s) $1 $2 - $+ $iif($3,$3,1)
}

alias linkedlist_inc {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
    }
    tokenize 32 $2-
  }
  var %name = $1, %node = $2, %num = $3
  if (($2) && (%node > 0)) {
    if (!%num) { %num = 1 }
    if ($linkedlist(%name)) {
      if ($linkedlist_node(%name,%node)) {
        if (%num isnum) {
          var %val = $linkedlist_node(%name,%node).data
          var %item = $linkedlist_node(%name,%node).item
          linkedlist_set %name %node data $calc(%val + %num)
          if ((%show) && ($show)) { linkedlist_info $iif(%num < 0,Dec,Inc) item ' $+ %item $+ ' in linked list ' $+ %name $+ ' (node: %node $+ ) }
        }
      }
      else {
        if ($show) { linkedlist_error linkedlist_ $+ $iif(%num < 0,dec,inc) no such node in ' $+ %name $+ ' (node: %node $+ )  }
      }
    }
    else {
      if ($show) { linkedlist_error linkedlist_ $+ $iif(%num < 0,dec,inc) no such linked list ' $+ %name $+ ' }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_ $+ $iif(%num < 0,dec,inc) insufficient parameters }
  }
}

alias linkedlist_set {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
    }
    tokenize 32 $2-
  }
  var %name = $1, %node = $2, %type = $3, %data = $4-
  if (($0 >= 3) && (%node >= 0)) {
    if ($linkedlist(%name)) {
      if ($linkedlist_node(%name,%node)) {
        var %nodename = $linkedlist_name(%name,%node)
        if (%type == data) {
          hadd %nodename data %data
          if ((%show) && ($show)) { linkedlist_info Data set to ' $+ %data $+ ' in ' $+ %name $+ ' (node: %node $+ ) }
        }
        elseif (%type == item) {
          hadd %nodename item %data
          if ((%show) && ($show)) { linkedlist_info Item set to ' $+ %data $+ ' in ' $+ %name $+ ' (node: %node $+ ) }
        }
        elseif (%type == next) {
          if ((%data isnum) || (%data == $null)) {
            hadd %nodename next %data
            if ((%show) && ($show)) { linkedlist_info Next set to ' $+ %data $+ ' in ' $+ %name $+ ' (node: %node $+ ) }
          }
        }
        else {
          if ($show) { linkedlist_error linkedlist_set bad syntax - set type must be item/data/next }
        }
      }
      else {
        if ($show) { linkedlist_error linkedlist_set no such node in ' $+ %name $+ ' (node: %node $+ )  }
      }
    }
    else {
      if ($show) { linkedlist_error linkedlist_set no such linked list ' $+ %name $+ ' }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_set insufficient parameters }
  }
}

alias linkedlist_find {
  var %name = $linkedlist_getname($1), %text = $2, %matchnum = $3, %type = $4, %matches = 0
  if (%name isnum) { return %name }
  %name = $gettok(%name,2,247)
  if ($isid) {
    if ($0 >= 3) {
      if ($linkedlist(%name)) {
        var %next = $linkedlist_node(%name,0).next
        while (%next != $null) {
          var %currentnode = %next
          var %check
          if ($prop == data) {
            %check = $linkedlist_node(%name,%currentnode).data
          }
          else {
            %check = $linkedlist_node(%name,%currentnode).item
          }
          if (%type == r) {
            if ($regex(%check,%text)) {
              inc %matches 1
              if (%matches == %matchnum) {
                return %currentnode
              }
            }
          }
          elseif (%type == w) {
            if (%text iswm %check) {
              inc %matches 1
              if (%matches == %matchnum) {
                return %currentnode
              }
            }
          }
          else {
            if (%text == %check) {
              inc %matches 1
              if (%matches == %matchnum) {
                return %currentnode
              }
            }
          }
          %next = $linkedlist_node(%name,%currentnode).next
        }
        if (%matchnum == 0) {
          return %matches
        }
        return
      }
      else {
        return
      }
    }
    else {
      return
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_node must be called as an identifier }
  }
}

alias linkedlist_swapAfter {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
    }
    tokenize 32 $2-
  }
  var %name = $1, %node1 = $2, %node2 = $3
  if ((%node1 >= 0) && (%node2 >= 0)) {
    var %next1 = $linkedlist_node(%name,%node1).next
    var %next2 = $linkedlist_node(%name,%node2).next
    var %next1.next = $linkedlist_node(%name,%next1).next
    var %next2.next = $linkedlist_node(%name,%next2).next
    if (%next1 && %next2) {
      if ($linkedlist_node(%name,%node1).next == %node2) {
        linkedlist_set %name %node1 next %next2
        linkedlist_set %name %next2 next %next1
        linkedlist_set %name %next1 next %next2.next
      }
      elseif ($linkedlist_node(%name,%node2).next == %node1) {
        linkedlist_set %name %node2 next %next1
        linkedlist_set %name %next2 next %next1.next
        linkedlist_set %name %next1 next %next2
      }
      else {
        linkedlist_set %name %node1 next %next2
        linkedlist_set %name %next2 next %next1.next
        linkedlist_set %name %node2 next %next1
        linkedlist_set %name %next1 next %next2.next
      }
      if (($show) && (%show)) { linkedlist_info Node ' $+ %next1 $+ ' swapped with ' $+ %next2 $+ ' in linked list ' $+ %name $+ ' }
    }
    else {
      if ($show) { linkedlist_error linkedlist_swapAfter Attempting to swap a node beyond the tail of the linked list }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_swapAfter insufficient parameters }
  }
}

alias linkedlist_sort {
  if ($left($1,1) == -) {
    if (s isin $1) {
      var %show = $true
      var %ticks = $ticks
    }
    tokenize 32 $2-
  }
  var %name = $1, %type = $2, %dir = $3, %minnode.prev, %min, %node.next
  if (%name) {
    if ($linkedlist(%name)) {
      if ((%type == desc) || (%type == asc)) {
        %dir = $2
      }
      var %eq
      if (%dir == desc) {
        %eq = >
      }
      else {
        %eq = <
      }
      var %prev = 0
      var %node = $linkedlist_node(%name,%prev).next
      while (%node != $null) {
        var %nextnode = $linkedlist_node(%name,%node).next
        if (%nextnode) {
          if (%type == item) {
            var %check = $linkedlist_node(%name,%node).item
          }
          else {
            var %check = $linkedlist_node(%name,%node).data
          }

          %min = %check

          var %next.prev = %node
          var %next.node = %nextnode
          while (%next.node != $null) {
            if (%type == item) {
              var %next.check = $linkedlist_node(%name,%next.node).item
            }
            else {
              var %next.check = $linkedlist_node(%name,%next.node).data
            }
            if (%next.check %eq %min) {
              %min = %next.check
              %minnode.prev = %next.prev
            }
            %next.prev = %next.node
            %next.node = $linkedlist_node(%name,%next.prev).next
          }
          if (%minnode.prev) {
            var %newprev = $linkedlist_node(%name,%minnode.prev).next
            linkedlist_swapAfter %name %minnode.prev %prev 
            var %newnode = $linkedlist_node(%name,%newprev).next
            %prev = %newprev
            %node = %newnode
          }
          else {
            %prev = %node
            %node = %nextnode
          }
        }
        else {
          %prev = %node
          %node = %nextnode
        }
        unset %minnode.prev
      }
      if (($show) && (%show)) { linkedlist_info Linked list ' $+ %name $+ ' sorted in $calc(($ticks - %ticks) / 1000) $+ secs }
    }
    else {
      if ($show) { linkedlist_error linkedlist_sort no such linked list ' $+ %name $+ ' }
    }
  }
  else {
    if ($show) { linkedlist_error linkedlist_sort insufficient parameters }
  }
}

alias -l linkedlist_getname {
  var %name = $1
  var %ll_name
  if (%name isnum) {
    var %n = 1, %max = $hget(0), %llnum = 0
    while (%n <= %max) {
      var %hash = $hget(%n)
      if (ll*0 iswm %hash) {
        inc %llnum 1
        if (%llnum == %name) {
          %ll_name = %hash
          break
        }
      }
      inc %n 1
    }
    if (%name == 0) { return %llnum }
  }
  else {
    %ll_name = $linkedlist_name(%name,0)
  }
  return %ll_name
}

alias -l linkedlist_name {
  return $+(ll,$1,,$2)
}

alias -l linkedlist_info {
  echo -a  $+ $color(info) $+ -
  echo -a  $+ $color(info) $+ * $1-
  echo -a  $+ $color(info) $+ -
}

alias -l linkedlist_error {
  linkedlist_info / $+ $1 $+ : $2-
}
